config/routes.rb
Rails.application.routes.draw do


  root to: "home#index"

  # Devise
  devise_for :users, controllers: { registrations: 'users/registrations' }
  
  # Users
  resources :users, only: [:index, :show, :edit, :update] do
    resources :follows, only: [:index, :create, :destroy]
    resources :bookmarks, only: [:index, :create, :destroy]
  end
  
  # Articles
  resources :articles do
    collection do 
      get :my
    end
    
    # Alternatives
    resources :alternatives, shallow: true do
      collection do
        post :update_all
      end
    end

    # Criteria
    resources :criteria, only: [:index]

    # Ratings
    resources :ratings, only: [:index]

    # Members
    resources :members, shallow: true do
      collection do
        get :new_request
      end
      member do
        get :approval
      end
    end
  end

  # Results
  get '/articles/:article_id/results' => 'results#index', as: :article_results
  get '/articles/:article_id/chart'   => 'results#chart', as: :article_chart

  # Visualization
  get '/articles/:article_id/viz'     => 'viz#index',    as: :article_viz
  get '/articles/:article_id/sankey'  => 'viz#sankey',   as: :article_sankey

  # Sensitivity Analysis 
  get '/articles/:article_id/sensitivity' => 'sensitivity#index',  as: :article_sensitivity
  get '/articles/:article_id/sensitivity_data' => 'sensitivity#data',  as: :article_sensitivity_data

  # Appraisal
  resources :appraisals, only: :destroy
  
  resources :criteria, only: [:show, :edit, :update, :destroy] do
    member do
      get :tree
      get 'new' => :new, as: :new
      post '' => :create, as: :create_sub
    end
    
    controller :direct_comparisons do
      get 'direct_comparisons/new'  => :new,    as: :new_direct_comparisons
      get 'direct_comparisons/edit' => :edit,   as: :edit_direct_comparisons
      post 'direct_comparisons'     => :create, as: :direct_comparisons
      patch 'direct_comparisons'    => :update
      put 'direct_comparisons'      => :update
    end

    controller :magiq_comparisons do
      get 'magiq_comparisons/new'  => :new,    as: :new_magiq_comparisons
      get 'magiq_comparisons/edit' => :edit,   as: :edit_magiq_comparisons
      post 'magiq_comparisons'     => :create, as: :magiq_comparisons
      patch 'magiq_comparisons'    => :update
      put 'magiq_comparisons'      => :update
    end

    controller :ahp_comparisons do
      get 'ahp_comparisons/new'  => :new,    as: :new_ahp_comparisons
      get 'ahp_comparisons/edit' => :edit,   as: :edit_ahp_comparisons
      post 'ahp_comparisons'     => :create, as: :ahp_comparisons
      patch 'ahp_comparisons'    => :update
      put 'ahp_comparisons'      => :update
    end

    controller :ratings do
      get 'ratings' => :show, as: :ratings
    end
  end

end

app/models/article.rb
class Article < ApplicationRecord

  acts_as_followable
  
  validates :title, presence: true 

  belongs_to :user
  has_many :alternatives, dependent: :destroy
  has_many :criteria, dependent: :delete_all
  has_many :members, dependent: :delete_all
  
  after_create :create_goal
  after_create :create_default_member
  after_save :check_goal

  scope :owned_by, -> (user) { where user: user }
  scope :with_criteria, -> { includes(:criteria) }
  scope :private_articles, -> { where(private: true) }
  scope :public_articles, -> { where.not(private: true) }

  def visibility
    private ? 'private' : 'public'
  end

  def public?
    !private? 
  end

  def delete_completely!
    criteria.destroy_all
    members.delete_all
    self.destroy
  end

  private

  def create_goal
    criteria.create title: title
  end

  def check_goal
    create_goal if criteria.blank?
  end
  
  def create_default_member
    members << Member.create(user:user, role:'owner', active:true, weight:1.0)
  end


end

app/controllers/articles_controller.rb
class ArticlesController < ApplicationController
  include TurbolinksCacheControl
  
  before_action :set_article, only: [:show, :edit, :update, :destroy]
  skip_before_action :authenticate_user!, :only => :show
  
  # GET /articles
  # GET /articles.json
  def index
    @articles = current_user.articles.paginate(page: params[:page])
    authorize! :read, @articles.first
  end

  def my
    @articles = current_user.articles.paginate(page: params[:page])
    authorize! :read, @articles.first
  end

  # GET /articles/1
  # GET /articles/1.json
  def show
    authorize! :read, @article
  end

  # GET /articles/new
  def new
    @article = Article.new user: current_user, private: false
    authorize! :create, @article
  end

  # GET /articles/1/edit
  def edit
    authorize! :update, @article
  end

  # POST /articles
  # POST /articles.json
  def create
    @article = Article.new(article_params)
    authorize! :create, @article
    if @article.save
      redirect_to @article, notice: 'Article was successfully created.'
    else
      render :new
    end
  end

  # PATCH/PUT /articles/1
  # PATCH/PUT /articles/1.json
  def update
    authorize! :update, @article
    if @article.update(article_params)
      redirect_to @article, notice: 'Article was successfully updated.' 
    else
      render :edit
    end
  end

  # DELETE /articles/1
  # DELETE /articles/1.json
  def destroy
    authorize! :destroy, @article
    @article.destroy
    respond_to do |format|
      format.html { redirect_to articles_url, notice: 'Article was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  def featured
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_article
      @article = Article.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def article_params
      params.require(:article).permit(:title, :description, :likes, :slug, :private, :active, :user_id)
    end

end

app/helpers/articles_helper.rb
module ArticlesHelper
  def my_articles
    Article.where(user:current_user)
  end
end

app/views/articles/_article.html.slim
tr.article id=id_for_bookmark(article, params[:fn]=='bookmarks')
  td.article
    .title
      span.star.info
        / FIXME: This is just a stub.
        i.icon-star
        i.icon-star
        i.icon-star
        i.icon-star-empty
        i.icon-star-empty
      .timestamp
        i.icon-time
        = "  #{time_ago_in_words(article.updated_at)} ago"	
    h5
      = link_to article.title, article, class: 'ellipsis'
    .description.formatted-output
      = raw truncate_html(description_snippet(article.description),500)
    .info
      span.author
        i.icon-user
        | &nbsp;Author:
        = link_to article.user.name, user_path(article.user.id)

    div.pull-right
      = render partial: 'bookmarks/bookmark_form', locals: { user: current_user, article: article }

app/views/articles/_article_content.html.slim
.widget
  .widget-header
    .ellipsis
      h3
        i.icon-file style="margin:0px"
        ' 
        = @article.title
  .well.well-widget-content
    .widget-content-title 
      = "#{@article.visibility} article"
    h2 = @article.title

    .article-attr 
      .t-label By:
      = link_to @article.user.name, @article.user
    -unless @article.description.blank?
      .clearfix
      br
      .formatted-output
        = raw(@article.description)
    .clearfix
    br
    #toolbar.button-toolbar
      = conditional_link_to edit_article_path(@article), can?(:update, @article), class:'btn btn-primary'
        i.icon-edit
        |  Edit
      -if current_user != @article.user
        span.pull-right
          = render partial: 'bookmarks/bookmark_form', locals: { user: current_user, article: @article }

app/views/articles/_form.html.slim
= form_with model: @article, class:'form-inline' do |f|
  = f.hidden_field :user_id, value: current_user.id
  .control-group
    = f.label :title, class: "control-label"
    .controls
      = f.text_field :title, class: 'input-xxlarge'
  .control-group
    = f.label :description, class: "control-label"
    .controls
      = f.text_area :description, class: 'input-xxlarge tinymce', data: {setup: "no"}, rows:10
  .row
    .span1 
    .span3
      .control-group 
        .controls 
          = f.check_box :private
          = f.label :private, class: "checkbox"
    .span3
      .control-group
        .controls 
          = f.check_box :active
          = f.label :active, class: "checkbox"

  #toolbar.button-toolbar
    = f.submit 'Save', class:'btn btn-primary', disable_with: 'Please wait...'
    = link_to @article, class:'btn' do
      i.icon-remove
      |  Cancel
    -if request[:action] == 'edit'
      = link_to @article, 
          method: :delete,
          class: "btn btn-danger pull-right", 
          data: {confirm: "This will delete the article and\nall related criteria and alternatives.\n\nThis action cannot be undone. Are you sure?"}
        i.icon-trash
        |  Delete

= tinymce

app/views/articles/_sidepanel.html.slim
.well.side-widget
  .side-widget-header
    a.resize-button data-toggle="collapse" data-target="#widget1" href="#" 
      i.icon-minus   
  .side-widget-title Article
  #widget1.collapse.in
    .side-widget-content
      .article-title
        = @article.title

    .side-widget-divider
    .side-widget-title Author
    .side-widget-content
      .article-author
        = @article.user.name
      -if @article.user != current_user
        div#follow-form class="ffbtn-#{@article.user_id} pull-right"
				  = render partial: 'follows/follow_form', locals: { user: @article.user }
    .clearfix
    .side-widget-divider

.well.side-widget
  .side-widget-header
    a.resize-button data-toggle="collapse" data-target="#widget2" href="#" 
      i.icon-minus
  .side-widget-title Article Stats
  #widget2.collapse.in
    .side-widget-content
      .article-prop 
        .ldef Created on 
        .rdef
          = @article.created_at.strftime "%b %d, %Y"
      .article-prop 
        .ldef Updated
        .rdef
          = "#{time_ago_in_words(@article.updated_at)} ago"
    .clearfix

    .side-widget-divider
    .side-widget-content
      table.stats
        tr
          td
            .stat-label = "Appreciations" 
            i.icon-thumbs-up
            span.stat-value#like-count = @article.likes

    .side-widget-divider.clearfix

app/views/articles/edit.html.slim
- page_title "Edit article"

= article_menu @article

- content_for :left_frame do
   = render partial: 'sidepanel'

#content-box
  = render 'shared/flash_messages'
  .widget
    .widget-header
      i.icon-edit
      h3 Edit Article
    .well.well-widget-content
      .widget-content-title
        | Editing article

      == render partial: 'form'

app/views/articles/index.html.slim
- page_title "Articles"

= article_menu
- content_for :left_frame do
 	= render partial: 'shared/user_profile', locals: { user: current_user }

#content-box
  = render 'shared/flash_messages'
  .widget
    .widget-header
      i.icon-file
      h3 Articles
    .well.well-widget-content
      - if current_user.articles.any?
        table.table.table-bordered.articles
          = render @articles
        = page_navigation_links @articles
      - else 
        .alert.alert-warning
          a.close data-dismiss="alert" ×
          | You don't have any article.

app/views/articles/my.html.slim
- page_title "My Articles"

= article_menu
- content_for :left_frame do
 	= render partial: 'shared/user_profile', locals: { user: current_user }
   
#content-box
  = render 'shared/flash_messages'
  .widget
    .widget-header
      i.icon-file
      h3 My articles
    .well.well-widget-content
      - if current_user.articles.any?
        table.table.table-bordered.articles
          = render @articles
        = page_navigation_links @articles
      - else 
        div 
          h4 You don't have any article.

app/views/articles/new.html.slim
- page_title "New article"

= article_menu
- content_for :left_frame do
   = render partial: 'shared/user_profile', locals: { user: current_user }

#content-box
  = render 'shared/flash_messages'
  .widget
    .widget-header
      i.icon-file
      h3 New article
    .well.well-widget-content
      .widget-content-title Create new article

      == render partial: 'form'

app/views/articles/show.html.slim
- page_title "Article"
= article_menu @article

- content_for :left_frame do
   = render partial: 'sidepanel'

#container-box
  = render 'shared/flash_messages'
  = render 'article_content'

app/views/articles/update_alternatives.js.erb
$('#flashes').html("<%= j render 'shared/flash_messages' %>");